// CoopOS Demo  (C) 2019 Helmut Weber  [ www.HelmutWeber.de ] Demo-2

// Task Control Block und Scheduler


struct tcb {
  void      (*Func)();      // Name des Tasks
  uint32_t    LastCalled;       // Zeit: letzter Aufruf 
  uint32_t    Delay;        // Verzögerung für Task
  char      State;        // Status: READY, DELAYED
};

#define MAXTASKS    10
int                 numTasks;

struct tcb          Tasks[MAXTASKS];

enum state          { READY, DELAYED };

// -------------------------------------------------

void Scheduler() {
uint32_t m=micros();
    for (int i=0; i<numTasks; i++) {
        if ((m-Tasks[i].LastCalled) >= Tasks[i].Delay) {
          Tasks[i].State = READY;
        }
        else Tasks[i].State=DELAYED;

        if (Tasks[i].State == READY) {
            Tasks[i].Func();
            Tasks[i].LastCalled = m;
        }
    } // for
} // Scheduler
// -------------------------------------------------



#define taskBegin()                                                            \
  static int _mark = 0;                                                        \
  switch (_mark) {                                                             \
  case 0:

#define taskEnd()    _mark=0;\
    return;  \
  }


#define taskSwitch() _mark=__LINE__; return;  case __LINE__:


void Task1() {
    taskBegin();
    while(1) {
      Serial.println("Task1 -1");
      taskSwitch();
      Serial.println("Task1 -2");
      
      taskSwitch();
      Serial.println("Task1 -3");

      taskSwitch();
      Serial.println("Task1 -4");

      taskSwitch();
    }
    taskEnd();
}



void Task2() {
static int _mark=0;
  switch(_mark) {
    case 0:
      Serial.println("           Task2 -1");
      _mark=1;
      return;
    case 1:
      Serial.println("           Task2 -2");
      _mark=0;
      return;  
  }
}




void setup() {
  Serial.begin(500000);
  delay(1000);
  for (int i=0; i<50; i++) Serial.println();
  Serial.println("(C) 2019 Helmut Weber [www.HelmutWeber.de]  CoopOS Demo-2\n");
  // -------------------------------------------------
  // Tasks initialisieren:
  Tasks[0].Func =  Task1;
  Tasks[0].State = DELAYED;
  Tasks[0].Delay = 500000;
  Tasks[0].LastCalled = micros();

  Tasks[1].Func =  Task2;
  Tasks[1].State = DELAYED;
  Tasks[1].Delay = 500000;
  Tasks[1].LastCalled = micros();

  numTasks=2;
  
  // -------------------------------------------------


}

void loop() {
  Scheduler();
}
