// CoopOS Demo  (C) 2019 Helmut Weber  [ www.HelmutWeber.de ] Demo-4


// Kosmetik:
// Auslagerung nach CoopOS.h
// Das Programm wird knapp und übersichtlich


#include "CoopOS.h"

// Globals
uint32_t  T_ID1, T_ID2;

void Task1() {
    taskBegin();
    while(1) {
      Serial.println("Task1 -1");         taskDelay(100000);
      Serial.println("Task1 -2");         taskDelay(200000);
      Serial.println("Task1 -3");         taskDelay(300000);
      Serial.println("Task1 -4");         taskDelay(400000);

      Serial.print("Task-Switches: ");
      taskSwitch();
      Serial.println(SchedulerCalls); SchedulerCalls=0;
      taskSwitch();
    }
    taskEnd();
}



void Task2() {
  taskBegin();
  while(1) {
    digitalWrite(5,HIGH);                 taskDelay(10);    // 10 µs HIGH
    digitalWrite(5,LOW);                  taskDelay(90);    // 90 µs LOW
  }
  taskEnd();
}

// -------------------------------------------------



void setup() {

  pinMode(5,OUTPUT);                      // Task2
  
#ifdef LA
  pinMode(15,OUTPUT);                     // Logic-Analyzer: Scheduler
#endif
  
  Serial.begin(500000);
  delay(1000);
  for (int i=0; i<50; i++) Serial.println();
  
  Serial.println("(C) 2019 Helmut Weber [www.HelmutWeber.de]  CoopOS Demo-4");
  
  // -------------------------------------------------
  // Tasks initialisieren:
  //int TaskInit(char *name, void (*f)(void), uint8_t priority, state stat, uint32_t del) 
  T_ID1=TaskInit(       "T1",      Task1,           50,               DELAYED,    5000000);
  T_ID2=TaskInit(       "T2",      Task2,           50,               READY,      0);

}





#ifdef NO_WLAN
void loop() {
  while(1) {
    Scheduler();
    ESP.wdtFeed();
  }
}

#else
void loop() {
  Scheduler();
}
#endif
