// CoopOS Demo  (C) 2019 Helmut Weber  [ www.HelmutWeber.de ] Demo-5


#include "CoopOS.h"

// Globals
// TaskHandles:
uint32_t  T_ID1, T_ID2, T_ID3, T_ID4;

void Task1() {
    taskBegin();
    while(1) {
      Serial.println("Task1 -1");         taskDelay(100000);
      Serial.println("Task1 -2");         taskDelay(200000);
      Serial.println("Task1 -3");         taskDelay(300000);
      Serial.println("Task1 -4");         taskDelay(400000);

      Serial.print("Task-Switches: ");
      taskSwitch();
      Serial.println(SchedulerCalls); SchedulerCalls=0;
      taskSwitch();
    }
    taskEnd();
}



void Task2() {
  taskBegin();
  while(1) {
    digitalWrite(5,HIGH);                 taskDelay(10);    // 10 µs HIGH
    digitalWrite(5,LOW);                  taskDelay(100);   // 100µs LOW
  }
  taskEnd();
}


void Task3() {
  taskBegin();
  while(1) {
    digitalWrite(12,HIGH);                 
    taskStopMe();
  }
  taskEnd();
}


void Task4() {
  taskBegin();
  while(1) {
    taskDelay(100);
    digitalWrite(12,LOW);
    taskResume(T_ID3);                    // reagiert "normalerweise" nach 2,5µs, wenn bei Init Platz 1
  }
  taskEnd();
}


// -------------------------------------------------



void setup() {

  pinMode(5,OUTPUT);                      // Task2
  pinMode(12,OUTPUT);                     // Task3, Task4
  
#ifdef LA
  pinMode(15,OUTPUT);                     // Logic-Analyzer: Scheduler
#endif
  
  Serial.begin(500000);
  for (int i=0; i<50; i++) Serial.println();
  
  Serial.println("(C) 2019 Helmut Weber [www.HelmutWeber.de]  CoopOS Demo-5");
  Serial.println("TaskInit ...");
  
  // -------------------------------------------------
  // Tasks initialisieren:
  //int TaskInit(char *name, void (*f)(void), uint8_t priority, state stat, uint32_t del) 
  T_ID3=TaskInit(       "T3",      Task3,           50,               READY,      0);
  T_ID1=TaskInit(       "T1",      Task1,           50,               DELAYED,    5000000);
  T_ID2=TaskInit(       "T2",      Task2,           50,               READY,      0);
//  T_ID3=TaskInit(       "T3",      Task3,           50,               READY,      0);
  T_ID4=TaskInit(       "T4",      Task4,           50,               READY,      0);
  Serial.println("TaskInit ready!");
  
}





#ifdef NO_WLAN
void loop() {
  while(1) {
    Scheduler();
    ESP.wdtFeed();
  }
}

#else
void loop() {
  Scheduler();
}
#endif
